﻿using Styx;
using Styx.Common;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SVNUpdater
{
    public partial class SVNUpdaterForm : Form
    {
        public SVNUpdaterForm()
        {
            InitializeComponent();
        }

        private void SVNUpdaterForm_Load(object sender, EventArgs e)
        {
            try
            {
                if (!SVNUpdater.readxml)
                {
                    SVNUpdaterdataSet1.ReadXml(SVNUpdater.svnxml);
                    SVNUpdater.readxml = true;
                }
            }
            catch (Exception ex)
            {
                Logging.WriteException(ex);
            }
        }

        private void SVNUpdaterForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                SVNUpdaterdataSet1.WriteXml(SVNUpdater.svnxml);
            }
            catch (Exception ex)
            {
                Logging.WriteException(ex);
            }
        }

        private void dataGridView1_CellValidating(object sender, DataGridViewCellValidatingEventArgs e)
        {
            string value = e.FormattedValue.ToString();
            if (!string.IsNullOrWhiteSpace(dataGridView1.Rows[e.RowIndex].Cells[0].FormattedValue.ToString()) &&
                e.ColumnIndex == 1 && !CheckURLValid(value))
            {
                MessageBox.Show("The Url " + e.FormattedValue + " is wrong Correct it");
                dataGridView1.CancelEdit();
            }
        }

        public bool CheckURLValid(string source)
        {
            Uri uriResult;
            return Uri.TryCreate(source, UriKind.Absolute, out uriResult) && (uriResult.Scheme == Uri.UriSchemeHttp || uriResult.Scheme == Uri.UriSchemeHttps);
        }

    }
}
